/*  Livid
 *
 * Copyright (C) 1999  Thomas Mirlacher, Guenter Bartsch
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "main.h"

#include "panel_gui.h"
#include "config_gui.h"
#include "config_store.h"
#include "playlist.h"

#include <pthread.h>
#include <nav/nav.h>

#include "messagebox.h" 
#include <stdio.h> 

struct player_global_struct player_global;
GtkWidget *widget_panel;
GtkWidget *widget_playlist;
GtkWidget *widget_config;

int main (int argc, char *argv[])
{
  player_global.bPLShowing    = FALSE;
  player_global.bConfShowing  = FALSE;
  
  g_thread_init(NULL) ;
  gtk_init (&argc, &argv);

  init_config ();
  read_config ();

  
  if (argc > 1) {
    if (navOpenInput (argv[1]) == DVD_PLAYER_NOT_FOUND)
      return -1;
  } else if (navOpenInput ("/dev/dvd") == DVD_PLAYER_NOT_FOUND) {
    return -1;
  }
  
//  navOpenOutput ("codec_dxr2.so", "/dev/output");
  navOpenOutput ("codec_sw.so", "/tmp/video");
//  navOpenOutput ("codec_ts.so", "/tmp/output.ts");
  
  widget_panel     = setup_panel ();
  widget_config    = setup_config ();
  widget_playlist  = setup_playlist ();
  
  gtk_widget_show (widget_panel);

  gdk_threads_enter();
  gdk_window_move(widget_panel->window,  
		  get_config_int_value ("xpos", 200), 
		  get_config_int_value ("ypos", 0));
  gdk_threads_leave();
  

  draw_panel_window(FALSE);
  
  gdk_threads_enter();
  gtk_main ();
  gdk_threads_leave();
  
  return 0;
}





