#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dlfcn.h>

#include "plugin/plugin.h"
#include "plugin/nav.h"
#include "nav.h"

static int fileOpen (plugin_t *plugin, char *path);
static int filePartPlayAutoStop (int title, int chapter, int parts2play);
static nav_tree_t *fileGetInfo (plugin_t *nav);

static struct {
	char *root;
	plugin_t *plugin;
} file_priv;

static plugin_nav_t file_nav = {
	fileOpen,
	NULL,
	filePartPlayAutoStop,
	fileGetInfo,
	NULL,
	NULL,
	&file_priv
};


/**
 *
 */

plugin_nav_t *plugin_init (void *foo)     
{     
        return &file_nav;     
}     


/**
 *
 */

void plugin_exit (void)
{
}


/**
 *
 */

static int fileOpen (plugin_t *plugin, char *path)
{
	file_priv.root = path;
	file_priv.plugin = plugin;

	if (pluginOpen (plugin, PLUGIN_ID_INPUT, DL_INPUT_FILE, path))
		return -1;

	if (pluginGetDecapsMagic (plugin, path))
		return -1;

	PLUGIN_OPS_INPUT(plugin)->blocksize = PLUGIN_OPS_DECAPS(plugin)->blocksize;
	PLUGIN_OPS_DECAPS(plugin)->read = PLUGIN_OPS_INPUT(plugin)->read;

	if (PLUGIN_OPS_CODEC(plugin))
		PLUGIN_OPS_DECAPS(plugin)->write = PLUGIN_OPS_CODEC(plugin)->read;

	PLUGIN_OPS_INPUT(plugin)->seek (0);
	PLUGIN_OPS_INPUT(plugin)->open ();

	PLUGIN_OPS_NAV(plugin) = & file_nav;

        return DVD_PLAYER_OK;
}


/**
 *
 */

static int filePartPlayAutoStop (int title, int chapter, int parts2play)
{
	PLUGIN_OPS_INPUT(file_priv.plugin)->seek (0);

	return DVD_PLAYER_OK;
}


/**
 *
 */

static nav_tree_t *fileGetInfo (plugin_t *nav)
{
	nav_tree_t *tree;

	tree = malloc (sizeof (nav_tree_t));

        tree->num = 1;
        tree->title = malloc (sizeof (nav_subtree_t) * tree->num);

	{
		nav_subtree_t *sub_tree = tree->title;
		sub_tree->sub = (nav_tree_data_t *) malloc (sizeof (nav_tree_data_t));
		sub_tree->num = 0;
		sub_tree->name = strdup (file_priv.root);
	}

	return tree;
}
