#ifndef DVD_UDF_H
#define DVD_UDF_H

#define DVD_UDF_VERSION 19991115

/* This is needed for 64 bit file seek */
#define _LARGEFILE64_SOURCE 1


/******************************************************************************/
/* The length of one Logical Block of a DVD Video                             */
/******************************************************************************/
#define DVD_VIDEO_LB_LEN 2048

/******************************************************************************/
/* reads Logical Block of the disc or image                                   */
/*   lb_number: disc-absolute logical block number                            */
/*   block_count: number of 2048 byte blocks to read                          */
/*   data: pointer to enough allocated memory                                 */
/*   returns number of read bytes on success, 0 on error                      */
/******************************************************************************/
int UDFReadLB(unsigned long int lb_number, unsigned int block_count, unsigned char *data);

/******************************************************************************/
/* looks for a file on the UDF disc/imagefile                                 */
/*   filename: absolute pathname on the UDF filesystem, starting with '/'     */
/*   returns absolute LB number, or 0 on error                                */
/******************************************************************************/
unsigned long int UDFFindFile(char *filename);

/******************************************************************************/
/* opens block device or image file                                           */
/*   filename: path to the DVD ROM block device or to the image file          *//*             in UDF format                                                  */
/*   returns fileno() of the file on success, or -1 on error                  */
/******************************************************************************/
int UDFOpenDisc(char *filename);

#endif /* DVD_UDF_H */
